%define	with_newlib 1

%define _prefix /opt/moxiedev
%define _sysconfdir /opt/moxiedev/etc

Name:		moxiedev-moxie-elf-gcc
Version:	4.10.0
Release:	0.50%{?dist}
Summary:	The GNU Compiler Collection targeting the moxie core

Group:		Development
License:	GPL
URL:		http://moxielogic.com/blog
Source0:	moxie-gcc.tar.gz
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:	moxiedev-moxie-elf-binutils flex bison texinfo gperf 
BuildRequires:  gmp-devel libmpc-devel zlib-devel
BuildRequires:  mpfr-devel
Requires:	moxiedev-moxie-elf-binutils moxiedev-moxie-elf-gcc-fsf-man-pages
%if %{with_newlib} == 1
BuildRequires:	moxiedev-moxie-elf-newlib
Requires:	moxiedev-moxie-elf-newlib
%endif

%description
The GNU Compiler Collection targeting the moxie core.

%package fsf-man-pages
Summary:  Common GCC man pages related to the FSF
Group:    Development/Tools

%description fsf-man-pages
Common man pages from the GCC distribution related to the Free
Software Foundation.

%if %{with_newlib} == 1
%package c++
Summary:  GNU C++ compiler for the moxie core
Group:    Development
Requires: moxiedev-moxie-elf-binutils moxiedev-moxie-elf-gcc

%description c++
GNU C++ compiler for the moxie core.

%package libstdc++
Summary:  C++ runtime library for the moxie core
Group:    Development/Libraries
Requires: moxiedev-moxie-elf-gcc-c++

%description libstdc++
C++ runtime library for the moxie core.
%endif

%prep
%setup -q -n gcc

# Extract %%__os_install_post into os_install_post~
cat << \EOF > os_install_post~
%__os_install_post
EOF

# Generate customized brp-*scripts
cat os_install_post~ | while read a x y; do
case $a in
# Prevent brp-strip* from trying to handle foreign binaries 
*/brp-strip*)
  b=$(basename $a)
  sed -e 's,find $RPM_BUILD_ROOT,find $RPM_BUILD_ROOT%_bindir $RPM_BUILD_ROOT%_libexecdir,' $a > $b
  chmod a+x $b
  ;;
esac
done

sed -e 's,^[ ]*/usr/lib/rpm.*/brp-strip,./brp-strip,' \
< os_install_post~ > os_install_post

%build

mkdir build
cd build
../configure \
  %_target_platform \
  --prefix=%_prefix \
  --exec-prefix=%_exec_prefix \
  --bindir=%_bindir \
  --sbindir=%_sbindir \
  --sysconfdir=%_sysconfdir \
  --datadir=%_datadir \
  --includedir=%_includedir \
  --libdir=%_libdir \
  --libexecdir=%_libexecdir \
  --localstatedir=%_localstatedir \
  --sharedstatedir=%_sharedstatedir \
  --mandir=%_mandir \
  --infodir=%_infodir \
  --enable-shared \
  --target=moxie-elf \
%if %{with_newlib} == 1
  --enable-languages=c,c++ \
  --with-newlib \
%else
  --enable-languages=c \
  --without-newlib \
%endif
  --disable-libquadmath \
  --disable-libssp
make %{?_smp_mflags}
cd ..

%install
rm -rf $RPM_BUILD_ROOT
cd build
make install DESTDIR=$RPM_BUILD_ROOT
cd ..
rm -rf $RPM_BUILD_ROOT%_datadir/locale
rm -rf $RPM_BUILD_ROOT%_infodir
# rm $RPM_BUILD_ROOT%{_libdir}/*.a

%define __os_install_post . ./os_install_post

%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%{_bindir}/*
%if %{with_newlib} == 1
%exclude %{_bindir}/moxie-elf-c++
%exclude %{_bindir}/moxie-elf-g++
%endif
%{_libdir}/gcc/moxie-elf
%{_prefix}/libexec/gcc/moxie-elf
%{_mandir}/man1/*
%doc COPYING*

%if %{with_newlib} == 1
%files c++
%defattr(-,root,root,-)
%{_bindir}/moxie-elf-c++
%{_bindir}/moxie-elf-g++

%files libstdc++
%defattr(-,root,root,-)
%{_prefix}/moxie-elf
%{_datadir}/gcc*
%endif

%files fsf-man-pages
%{_mandir}/man7/*

%changelog
* Fri May 09 2014 Anthony Green <green@moxielogic.com> 4.10.0-1
- Created.

